APROPOS(1)

NAME
apropos, whatis - search manual page databases

SYNOPSIS
apropos [-afk] [-C file] [-M path] [-m path] [-O outkey] [-S arch] [-s section] expression ...

DESCRIPTION
The apropos and whatis utilities query manual page databases generated by makewhatis(8), evaluating expression for each file in each database. By default, they display the names, section numbers, and description lines of all matching manuals.

By default, apropos searches for makewhatis(8) databases in the default paths stipulated by man(1) and uses case-insensitive extended regular expression matching over manual names and descriptions (the apropos and - macro keys). Multiple terms imply pairwise -o.

whatis is a synonym for apropos -f.

The options are as follows:

-a  Instead of showing only the title lines, show the complete manual pages, just like man(1) -a would. If the standard output is a terminal device and -c is not specified, use less(1) to paginate them. In -a mode, the options -IKOTW described in the mandoc(1) manual are also available.

-C file
    Specify an alternative configuration file in man.conf(5) format.

-f  Search for all words in expression in manual page names only. The search is case-insensitive and matches whole words only. In this mode, macro keys, comparison operators, and logical operators are not available.

-k  Support the full expression syntax. It is the default for apropos.

-M path
    Use the colon-separated path instead of the default list of paths searched for makewhatis(8) databases. Invalid paths, or paths without manual databases, are ignored.

-m path
    Prepend the colon-separated paths to the list of paths searched for makewhatis(8) databases. Invalid paths, or paths without manual databases, are ignored.

-O outkey
    Show the values associated with the key outkey instead of the manual descriptions.

-S arch
    Restrict the search to pages for the specified machine(1) architecture. arch is case-insensitive. By default, pages for all architectures are shown.

-s section
    Restrict the search to the specified section of the manual. By default, pages from all sections are shown. See man(1) for a listing of sections.

The options -chlw are also supported and are documented in man(1). The options -fkl are mutually exclusive and override each other.

An expression consists of search terms joined by logical operators -a (and) and -o (or). The -a operator has precedence over -o and both are evaluated left-to-right.

(expr)
    True if the subexpression expr is true.

expr1 -a expr2
    True if both expr1 and expr2 are true (logical ‘and’).

expr1 [-o] expr2
    True if expr1 and/or expr2 evaluate to true (logical ‘or’).

term
    True if term is satisfied. This has syntax [ [key[,key...]] (=|~)] val, where key is an mdoc(7) macro to query and val is its value. See Macro Keys for a list of available keys. Operator = evaluates a substring, while ~ evaluates a case-sensitive extended regular expression.

-i term
    If term is a regular expression, it is evaluated case-insensitively. Has no effect on substring terms.

Results are sorted first according to the section number in ascending numerical order, then by the page name in ascending ascii(7) alphabetical order, case-insensitive.

Each output line is formatted as

    name[, name...](sec) - description

Where “name” is the manual's name, “sec” is the manual section, and “description” is the manual's short description. If an architecture is specified for the manual, it is displayed as

    name(sec/arch) - description

Resulting manuals may be accessed as

    $ man -s sec name

If an architecture is specified in the output, use

    $ man -s sec -S arch name

  Macro Keys
Queries evaluate over a subset of mdoc(7) macros indexed by makewhatis(8). In addition to the macro keys listed below, the special key any may be used to match any available macro key.

Names and description:
apropos | manual name
- | one-line manual description
arch | machine architecture (case-insensitive)
sec | manual section number

Sections and cross references:
Sh | section header (excluding standard sections)
Ss | subsection header
 | cross reference to another manual page
Rs | bibliographic reference

Semantic markup for command line utilities:
- | command line options (flags)
 | command modifier
file ... | command argument
 | internal or interactive command
 | environmental variable
~ | file system path

Semantic markup for function libraries:
 | function library name
 | include file
 | function return type
 | function name
 | function argument type and name
 | variable type
 | variable name
 | defined variable or preprocessor constant
 | error constant
 | environmental variable

Various semantic markup:
 | author name
 | hyperlink
~ | “mailto” hyperlink
 | kernel configuration declaration
 | mathematical symbol
 | tradename

Physical markup:
 | italic font or underline
 | boldface font
 | typewriter font

Text production:
 | reference to a standards document
AT&T UNIX | AT&T UNIX version reference
BSD | BSD version reference
BSD/OS | BSD/OS version reference
NetBSD | NetBSD version reference
FreeBSD | FreeBSD version reference
OpenBSD | OpenBSD version reference
DragonFly | DragonFly version reference

In general, macro keys are supposed to yield complete results without expecting the user to consider actual macro usage. For example, results include:

    function arguments appearing on lines
    function names marked up with ( macros
    include file names marked up with Fd macros
    types appearing as function return types and
    types appearing in function arguments in the SYNOPSIS

ENVIRONMENT

MANPAGER
    Any non-empty value of the environment variable MANPAGER is used instead of the standard pagination program, less(1); see man(1) for details. Only used if -a or -l is specified.

MANPATH
    A colon-separated list of directories to search for manual pages; see man(1) for details. Overridden by -M, ignored if -l is specified.

PAGER
    Specifies the pagination program to use when MANPAGER is not defined. If neither PAGER nor MANPAGER is defined, less(1) is used. Only used if -a or -l is specified.

FILES
mandoc.db
    name of the makewhatis(8) keyword database
/etc/man.conf
    default man(1) configuration file

EXIT STATUS

EXAMPLES
Search for ".cf" as a substring of manual names and descriptions:

    $ apropos =.cf

Include matches for ".cnf" and ".conf" as well:

    $ apropos =.cf =.cnf =.conf

Search in names and descriptions using a case-sensitive regular expression:

    $ apropos '~set.?[ug]id'

Search for manuals in the library section mentioning both the "optind" and the "optarg" variables:

    $ apropos -s 3 Va=optind -a Va=optarg

Do exactly the same as calling whatis with the argument "ssh":

    $ apropos -- -i 'Nm~[[:<:]]ssh[[:>:]]'

The following two invocations are equivalent:

    $ apropos -S arch -s section expression

$ apropos \( expression \) -a arch~^(arch|any)$ -a sec~^section$

SEE ALSO
man(1), re_format(7), makewhatis(8)

STANDARDS
The apropos utility is compliant with the p1003.1-2008 specification of man(1) -k.

All options, the whatis command, support for logical operators, macro keys, substring matching, sorting of results, the environment variables MANPAGER and MANPATH, the database format, and the configuration file are extensions to that specification.

HISTORY
Part of the functionality of whatis was already provided by the former manwhere utility in 1BSD. The apropos and whatis utilities first appeared in 2BSD. They were rewritten from scratch for OpenBSD 5.6.

The -M option and the MANPATH variable first appeared in 4.3BSD; -m in 4.3BSD Reno; -C in 4.4BSD Lite1; and -S and -s in OpenBSD 4.5 for apropos and in OpenBSD 5.6 for whatis. The options -acfhIKklOTWw appeared in OpenBSD 5.7.

AUTHORS
-nosplit Bill Joy wrote manwhere in 1977 and the original BSD apropos and whatis in February 1979. The current version was written by Kristaps Dzonsons <kristaps@bsd.lv> and Ingo Schwarze <schwarze@openbsd.org>.